#!/bin/sh

# parse_query routine
# 

# Copyright 2018 Ayrstone Productivity


echo "Content-type: text/html"
echo ""
echo "<html><head><meta content='text/html; charset=ISO-8859-1' http-equiv='content-type'><Title>AyrMesh Hub2T</Title><link rel='stylesheet' type='text/css' href='../style.css'></head>"
echo "<body><div id=main><h1 style='text-align: center;'><img style='width: 272px; height: 60px;' alt='Ayrstone Logo' src='../ayrstone.jpg'></h1>"
echo "<h1 style='text-align: center;'>Ayrstone AyrMesh<sup>&reg;</sup> Hub2T</h1>"
echo "<hr>"
# Parse the input
# checkin=on ip_type=DHCP address=192.168.1.1 netmask=255.255.255.0 gateway=192.168.1.1 mesh_on=on mesh_id=6aef335c73103a1f mesh_key=f0d17362351e8f54 wifi_on=on channel=6 ssid=AyrMesh encrypt_type=mixed-psk encrypt_key=Ayrmesh1 uname=username pword1=password pword2=password submit=Submit 
# note that, if check box is not checked, there is NO checkin in the string
checkin="off"
mesh_on="off"
wifi_on="off"
eval $(echo "$QUERY_STRING"|awk -F'&' '{for(i=1;i<=NF;i++){print $i}}')
# Cheat - the passkey always gets set to get around bad passkey from AyrMesh.com
uci set ayrmesh.param.encryption_key=$encrypt_key
uci commit ayrmesh                                                                 
# If checkin is not checked, there is no checkin variable. 
if [ "$checkin" != "on" ]; then
	uci set ayrmesh.param.checkin=0
	uci set ayrmesh.param.rescue=0
	if [ "$ip_type" == "DHCP" ]; then
		uci set network.lan.proto=dhcp
	else
		uci set network.lan.proto=static
		uci set network.lan.ipaddr=$address
		uci set network.lan.netmask=$netmask
		uci set network.lan.gateway=$gateway
	fi
	if [ "$mesh_on" == "on" ]; then
		uci set wireless.mesh.disabled=0
		uci set wireless.mesh.mesh_id=$mesh_id
		uci set wireless.mesh.key=$mesh_key
		uci set ayrmesh.param.mesh_on=1
		uci set ayrmesh.param.mesh_id=$mesh_id
		uci set ayrmesh.param.mesh_key=$mesh_key
	else
		uci set wireless.mesh.disabled=1
		uci set ayrmesh.param.mesh_on=0
	fi
	if [ "$wifi_on" == "on" ]; then
		uci set wireless.AP.disabled=0
		uci set wireless.AP.ssid=$ssid
# test for mixed-psk bug
		if [ ${encrypt_type} == "mixed-psk" ]; then
			new_encrypt_value='psk-mixed+tkip+aes'
		else
			new_encrypt_value=$encrypt_type	
		fi					
		uci set wireless.AP.encryption=$new_encrypt_value
		uci set wireless.AP.key=$encrypt_key
		uci set wireless.radio0.channel=$channel
		uci set ayrmesh.param.wifi_on=1
		uci set ayrmesh.param.ssid=$ssid
		uci set ayrmesh.param.encryption=$encrypt_type
		uci set ayrmesh.param.encryption_key=$encrypt_key
		uci set ayrmesh.param.channel=$channel
	else
		uci set wireless.AP.disabled=1
		uci set ayrmesh.param.wifi_on=0
	fi
	uci set ayrmesh.param.username=${uname}
	password=`uci get ayrmesh.param.password`
	if [ "$pword1" == "$pword2" ]; then
		uci set ayrmesh.param.password=${pword1}
		password=${pword1}
	else
		echo "<p>Password did not match; password not changed.</p>"
	fi
	# setup webserver to log in with new credentials
	echo "A:*" >/etc/httpd.conf
	echo "/cgi-bin:${uname}:${password}" >>/etc/httpd.conf
	uci commit network
	uci commit wireless
	uci commit ayrmesh
	echo "<p>Hub2T is under manual control and changes have been saved.</p>"
	/etc/init.d/network reload
else
	
	echo "<p>Settings are now in control of AyrMesh.com - rebooting </p>"
	uci set ayrmesh.param.checkin=1
	uci set ayrmesh.param.rescue=1
	uci set ayrmesh.param.mesh_on=1
	uci set ayrmesh.param.wifi_on=1
	uci set network.lan.proto=dhcp
	uci commit ayrmesh
	uci commit network
	sync
    reboot
fi


echo "</body></html>"
# restart webserver
pkill httpd
httpd -h /etc/www -c /etc/httpd.conf -p 80
exit
#done
