#!/bin/sh
# /etc/www/cgi-bin/settings.cgi
# Copyright (C) 2016 Ayrstone Productivity LLC - ayrstone.com - all rights reserved
. /lib/ayr_functions

get_params

ip_addr=`ifconfig br-lan| grep "inet addr" |cut -d: -f2 |awk '{print $1}'`
# Header
echo "Content-type: text/html"
echo ""
echo "<html><head><meta content='text/html; charset=ISO-8859-1' http-equiv='content-type'><Title>AyrMesh Hub2T</Title><link rel='stylesheet' type='text/css' href='../style.css'></head>"
echo "<body><div id=main><h1 style='text-align: center;'><img style='width: 272px; height: 60px;' alt='Ayrstone Logo' src='../ayrstone.jpg'></h1>"
echo "<h1 style='text-align: center;'>Ayrstone AyrMesh<sup>&reg;</sup> Hub2T</h1>"
echo "<hr>"
echo "<form method='get' action='apply_settings.cgi' name='settings'>"
# Ayrmesh-specific
echo "<h2>AyrMesh-specific Setting:</h2><br>"
if [ $checkin -eq 1 ]; then
	echo "<input checked='checked' tabindex='1' name='checkin' title='Settings below here will only be effective if this is unchecked' value='on'type='checkbox'>Check in to AyrMesh.com<br>"
else
	echo "<input tabindex='1' name='checkin' title='Settings below here will only be effective if this is unchecked' value='on'type='checkbox'>Check in to AyrMesh.com<br>"
fi
echo "<br>Settings below here will only be effective if 'Check into AyrMesh.com' is unchecked <br><hr><br>"
echo "<h2>General Settings:</h2>"
if [ $(uci get network.lan.proto) == "dhcp" ]; then
	echo "IP Address type: <br><input tabindex='2' checked='checked' name='ip_type' value='DHCP' type='radio'>DHCP <br><input tabindex='3' name='ip_type' value='Static' type='radio'>Static Address: <input maxlength='32' tabindex='4' title='Enter an IPv4 address'name='address' value='$(uci get network.lan.ipaddr)'> Netmask: <input maxlength='32' tabindex='5' title='Enter an IPv4 netmask' name='netmask' value='$(uci get network.lan.netmask)'> Gateway: <input maxlength='32' tabindex='6' title='Enter the gateway IP' name='gateway' value='$(uci get network.lan.gateway)'><br>"
else
	echo "IP Address type: <br><input tabindex='2' name='ip_type' value='DHCP' type='radio'>DHCP <br><input tabindex='3' name='ip_type' value='Static' checked='checked' type='radio'>Static Address: <input maxlength='32' tabindex='4' title='Enter an IPv4 address'name='address' value='$(uci get network.lan.ipaddr)'> Netmask: <input maxlength='32' tabindex='5' title='Enter an IPv4 netmask' name='netmask' value='$(uci get network.lan.netmask)'> Gateway: <input maxlength='32' tabindex='6' title='Enter the gateway IP' name='gateway' value='$(uci get network.lan.gateway)'><br>"
fi
echo "</select><br>"
echo "<h2>Mesh Settings:</h2>"
if [ $mesh_on -eq 1 ]; then
	echo "<input checked='checked' tabindex='7' name='mesh_on' title='Mesh active' value='on'type='checkbox'>Mesh feature on<br>"
else
	echo "<input tabindex='7' name='mesh_on' title='Mesh active' value='on'type='checkbox'>Mesh feature on<br>"
fi
echo "Mesh ID: <input maxlength='32' tabindex='8' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' name='mesh_id'value=$mesh_id><br>"
echo "Mesh Key: <input maxlength='32' tabindex='9' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' name='mesh_key'value=$mesh_key><br>"
echo "<h2>WiFi Settings:</h2>"
if [ $wifi_on -eq 1 ]; then
	echo "<input checked='checked' tabindex='10' name='wifi_on' title='WiFi Active' value='on' type='checkbox'>WiFi Access Point on<br>"
else
	echo "<input tabindex='10' name='wifi_on' title='WiFi Active' value='on' type='checkbox'>WiFi Access Point on<br>"
fi
echo "Channel:<select size='1' tabindex='11' title='Select Channel' name='channel'>"
for select_channel in 1 2 3 4 5 6 7 8 9 10 11
do
	printf "<option"
	if [ $select_channel -eq $channel ]; then
		printf " selected='selected'>"
	else

		printf ">"
	fi
	printf $select_channel"</option>"
done
echo "</select><br>SSID: <input tabindex='12' name='ssid' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' value='$ssid'><br>"
echo "Encryption type: <select size='1' tabindex='13' title='None is no encryption, mixed-psk is for WPA or WPA2, and psk2 is for WPA2 only' name='encrypt_type'>"
for select_encrypt in 'none' 'mixed-psk' 'psk2'
do
	printf "<option"
	if [ $select_encrypt == $encryption ]; then
		printf " selected='selected'>"
	else

		printf ">"
	fi
	printf $select_encrypt"</option> "
done
echo "</select><br> Encryption key: <input tabindex='14' name='encrypt_key' title='up to 32 characters, do not use spaces, percent, dollar sign, pound sign, or backslash' value='$encryption_key'><br><br>"
echo "<h2>Username and Password:</h2>"
echo "</select><br>Username: <input tabindex='15' name='uname' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' value='$username'>"
echo "</select><br>New Password: <input tabindex='16' name='pword1' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' value='$password'>"
echo "</select><br>Please type new Password again: <input tabindex='17' name='pword2' title='up to 32 characters, do not use spaces, percent, dollar sign, or backslash' value='$password'><br>"
echo "<br><input tabindex='18' name='submit' value='Submit' type='submit'><br></form>"
echo "</body></html>"

