#!/bin/sh
# /etc/www/cgi-bin/status.cgi
# Copyright (C) 2015 Ayrstone Productivity LLC - ayrstone.com - all rights reserved
. /lib/ayr_functions

get_params

# from /sbin/ayr_checkin
btime=`grep btime /proc/stat | awk '{print $2'}`
time=`date +"%s"`
uptime=$((time-btime))
#uptime=`uptime |cut -d, -f1`
if [ $uptime -gt 0 ]; then
	days=$(( uptime / 86400))
	uptime=$(( uptime \% 86400))
	hours=$(( uptime / 3600))
	uptime=$(( uptime \% 3600))
	min=$(( $uptime / 60))
	uptime=`printf "%0dd:%0dh:%02dm" $days $hours $min`
else
	uptime=0d:0h:0m
fi
memfree=`free |grep "Mem:" |awk '{print $4}'`
# It appears OpenWRT puts the device MAC address on the wlan0 device.
mac=`ifconfig |grep wlan0 |grep -v wlan0-1 |awk '{print $5}'`
ip_addr=`ifconfig br-lan| grep "inet addr" |cut -d: -f2 |awk '{print $1}'`
# firmware version
version=`cat /etc/ayrmesh_version`
load=`top -b -n 1 |grep "Load" |head -1 |awk '{print $3 "," $4 "," $5}'`
if [ $gateway -eq 1 ]; then
	role=Gateway
else
	role=Remote
fi

signal=$(iw dev $mesh_iface station dump |grep signal: |cut -d: -f2 |sort |head -1 |awk '{print $1}')

/sbin/ayr_status >/dev/null
thruput=$(uci get ayrmesh.param.thruput)

echo "Content-type: text/html"
echo ""
echo "<html><head><meta content='text/html; charset=ISO-8859-1' http-equiv='content-type'><Title>AyrMesh Hub2T</Title><link rel='stylesheet' type='text/css' href='../style.css'></head>"
echo "<body><div id=main><h1 style='text-align: center;'><img style='width: 272px; height: 60px;' alt='Ayrstone Logo' src='../ayrstone.jpg'></h1>"
echo "<h1 style='text-align: center;'>Ayrstone AyrMesh<sup>&reg;</sup> Hub2T</h1>"
echo "<hr><table width=700>"
echo "<tr><td>Role: <span style='color:green'>${role}</span></td><td> MAC address: <span style='color:green'>${mac}</span></td></tr>"
echo "<tr><td>IP address: <span style='color:green'>${ip_addr}</span></td><td>Channel: <span style='color:green'>${channel}</span></td></tr>"
echo "<tr><td> SSID: <span style='color:green'>${ssid}</span></td>"
if [ $gateway -ne 1 ]; then
	echo "<td> Throughput to gateway: <span style='color:green'>${thruput} Mbps</span></td></tr>"
else
	echo "<td></td></tr>"
fi
echo "<tr><td>Signal strength to next Hub: <span style='color:green'>$signal dBi</span></td><td>Firmware version: <span style='color:green'>$version</span></td></tr>"
echo "<tr><td>Memory free: <span style='color:green'>$memfree</span> </td><td>Load: <span style='color:green'>${load}</span> </td></tr>"
echo "<tr><td>Uptime: <span style='color:green'>$uptime</span></td></tr>"
echo "</table><hr>"
echo "</div>"
echo "<h3>Site Survey</h3>"
echo "<pre>"
echo "    MAC addr     Chan Signal SSID"
/sbin/ayr_site_survey
echo "</pre>"
echo "<h3>Client List</h3>"
echo "<pre>"
client_list
echo "</pre>"
echo "<h3>---End---</h3>"
echo "</body></html>"

